-- Functions to encode numbers in german and french versions
-- found at KragenBars
-- http://svn.lotrointerface.com/filedetails.php?repname=KragenBars&path=%2Fbranches%2F321%2FKragenBars%2FMain.lua&rev=68

SettingsEncoder = class();
locale = Turbine.Engine.GetLocale();

function SettingsEncoder:EncodeTable(data)
        if ((locale == "fr" or locale == "de") and data ~= nil) then
                local newdata = {};
                local newkey = nil;
                
                for k,v in pairs(data) do
                        if (type(k) == "number") then
                                newkey = ("<num>%f</num>"):format(k);
                        else
                                newkey = k;
                        end
                        if (type(data[k]) == "number") then
                                newdata[newkey] = ("<num>%f</num>"):format(data[k]);
                        elseif(type(data[k]) == "table") then
                                newdata[newkey] = EncodeTable(data[k]);
                        else
                                newdata[newkey] = data[k];
                        end
                end
                return newdata;
        else
                return data;
        end
end

function SettingsEncoder:DecodeTable(data)
        if ((locale == "fr" or locale == "de") and data ~= nil) then
                local newdata = {};
                local newkey = nil;
        
                for k,v in pairs(data) do
                        if (type(k) == "string") then
                                local match = k:match("<num>(%d+.%d+)</num>");
                                if (match ~= nil) then
                                        newkey = tonumber(match);
                                else
                                        newkey = k;
                                end
                        else
                                newkey = k;
                        end
                        if (type(data[k]) == "string") then
                                local match = data[k]:match("<num>(%d+.%d+)</num>");
                                if (match ~= nil) then
                                        newdata[newkey] = tonumber(match);
                                else
                                        newdata[newkey] = data[k];
                                end
                        elseif(type(data[k]) == "table") then
                                newdata[newkey] = DecodeTable(data[k]);
                        else
                                newdata[newkey] = data[k];
                        end
                end
                return newdata;
        else
                return data;
        end
end